#pragma once

#include "stdafx.h"

using namespace std;

int GetRenameFileName()
{
	if (debugging == 1) Debug << L"GetRenameFileName Fired" << endl;
	GetDlgItemText(hSettings,IDC_RENAME_FOLDER,RenameFileNamePath,250);
    RenameFolder = wchar_t2wstr(RenameFileNamePath);
    RenameDirectoryPath = WExtractDirectory(RenameFolder);
	if (debugging == 1) Debug << L"GetRenameFileName Completed" << endl;
	return 0;
}

bool ListFilesRename(wstring path, wstring mask, vector<wstring>& files) { 
	HANDLE hFind = INVALID_HANDLE_VALUE; 
	WIN32_FIND_DATA ffd; 
	wstring spec; 
	stack<wstring> directories; 
	directories.push(path); 
	files.clear(); 
	if (rename_recurse_subfolders == 1) {
		//cout << "recurse" << endl;
		while (!directories.empty()) { 
			path = directories.top(); 
			spec = path + L"\\" + mask; 
			directories.pop(); 
			hFind = FindFirstFile(spec.c_str(), &ffd); 
			if (hFind == INVALID_HANDLE_VALUE)  { 
				return false; 
			}  
			do { 
				if (wcscmp(ffd.cFileName, L".") != 0 &&  
				wcscmp(ffd.cFileName, L"..") != 0) { 
					if (ffd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) { 
						directories.push(path + L"\\" + ffd.cFileName);
					} 
					else { 
						files.push_back(path + L"\\" + ffd.cFileName); 
					} 
				} 
			} while (FindNextFile(hFind, &ffd) != 0); 
			if (GetLastError() != ERROR_NO_MORE_FILES) { 
				FindClose(hFind); 
				return false; 
			} 
			FindClose(hFind); 
			hFind = INVALID_HANDLE_VALUE; 
		} 
	    return true; 
	} else if (rename_recurse_subfolders == 0) {
		if (!directories.empty()) { 
			path = directories.top(); 
			spec = path + L"\\" + mask; 
			directories.pop(); 
			hFind = FindFirstFile(spec.c_str(), &ffd); 
			if (hFind == INVALID_HANDLE_VALUE)  { 
				return false; 
			}  
			do { 
				if (wcscmp(ffd.cFileName, L".") != 0 &&  
				wcscmp(ffd.cFileName, L"..") != 0) { 
					if (ffd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) { 
						directories.push(path + L"\\" + ffd.cFileName);
					} 
					else { 
						files.push_back(path + L"\\" + ffd.cFileName); 
					} 
				} 
			} while (FindNextFile(hFind, &ffd) != 0); 
			if (GetLastError() != ERROR_NO_MORE_FILES) { 
				FindClose(hFind); 
				return false; 
			} 
			FindClose(hFind); 
			hFind = INVALID_HANDLE_VALUE; 
		}  
	}
	return true;
} 

void ProcessRenameRecurseFiles()
{ 
	if (debugging == 1) Debug << L"ProcessRenameRecurseFiles() Fired " << endl;
	GreyDialogSettings();
	GetRenameFileName();
	RRLOG.open(L"ReplaceRename.log",ios::trunc);
	if(RRLOG.bad()) {
		MessageBoxW(NULL, L"Opening of log failed ->", L"ReplaceRename.log", NULL);
	}
	if (debugging == 1) Debug << L"ProcessRenameRecurseFiless() Multiple Files " << endl;
	vector<wstring> files; 
	if (debugging == 1) Debug << L"ProcessRenameRecurseFiles() path " << RenameDirectoryPath << endl;
	RRLOG << L"Starting in : " << RenameDirectoryPath << endl;
	if (ListFilesRename(RenameDirectoryPath, L"*.*", files))  
	{ 
		if (debugging == 1) Debug << L" ListFiles starting in -> " << RenameDirectoryPath << endl;
		for (vector<wstring>::iterator it = files.begin();it != files.end(); ++it) 
		{
			wchar_t* Name = cwchar_t2wchar_t(it->c_str());
			if (debugging == 1) Debug << L" ListFiles files.begin() " << endl;
			number_of_files_searched++;
			InputFile = wchar_t2wstr(Name);
			wstring value = L"Found file ";
			value.append(InputFile);
			value.append(L".");
			cursor_select++;
			Insert_Item_Into_Console(value);
			RRLOG << value << endl;
			if (debugging == 1) Debug << L" file name ->>" << InputFile << endl;
			TrackRenamedFiles+=ProcessRenameFiles(InputFile);
		} 
	}
	if (debugging == 1) Debug << L"ProcessRenameRecurseFiles() Completed" << endl;
    SetDialogSettingsSpecific(1);
	wstring value = L"Searched ";
	value.append(int2wstr(number_of_files_searched));
	value.append(L" total files.Renamed ");
	value.append(int2wstr(TrackRenamedFiles));
	value.append(L" total files.");
	cursor_select++;
	Insert_Item_Into_Console(value);
	hConsole = GetDlgItem(hSettings,IDC_CONSOLE_LIST);
	SendMessage(hConsole,LVM_ENSUREVISIBLE ,(WPARAM)cursor_select,FALSE);
	RRLOG << value << endl;
	RRLOG.close();
}

int ProcessRenameFiles(wstring InputFileName) 
{
	if (debugging == 1) Debug << L"ProcessRenameFiles fired" << endl;
	wstring look_for = L"";
	wstring replace_with = L"";
	wstring WorkingOutputFileName = cpywstr(WExtractFileName(InputFileName));
	wstring WorkingOutputDirectory = cpywstr(WExtractDirectory(InputFileName));
	for (int j = 150;j < 300;j++)
	{
		{
			for (int Step = 0;Step < 2;Step++)
			{
				if (Step == 0)
				{
					look_for = cpywstr(StringsArray[j][Step]);
				} 
				else if (Step == 1) 
				{
					replace_with = cpywstr(StringsArray[j][Step]);
					if (debugging == 1) Debug << L"replace_with-> " << replace_with << L" look_for-> " << look_for << endl;
					if ((look_for.compare(L"Not Being Used") != 0 && replace_with.compare(L"Not Being Used") != 0) && (look_for.compare(L"") != 0 && replace_with.compare(L"") != 0) && (look_for.compare(replace_with) != 0) && (replace_with.compare(look_for) != 0))
					{
						if (debugging == 1) Debug << L"WorkingOutputFileName Before replace-> " << WorkingOutputFileName << endl;
						WorkingOutputFileName = CSI_Replacew(look_for,WorkingOutputFileName,replace_with);
						if (debugging == 1) Debug << L"WorkingOutputFileName After replace-> " << WorkingOutputFileName << endl;
					}
				}
			}
		}
	}
	wstring FinnalOutputFileName = cpywstr(WorkingOutputDirectory.append(WorkingOutputFileName));
	if (!CSI_CompareRenamew(FinnalOutputFileName,InputFileName)) 
	{
		int RenameSucessfull = rename(wstr2str(InputFileName).c_str(),wstr2str(FinnalOutputFileName).c_str());
		if (RenameSucessfull == 0) {
			wstring value = L"Renamed ";
			value.append(WExtractDirectory(InputFileName));
			value.append(L" to ");
			value.append(WorkingOutputFileName);
			value.append(L" successfully.");
			cursor_select++;
			Insert_Item_Into_Console(value);
			RRLOG << value << endl; 
			if (debugging == 1) Debug << L"ProcessFiles WorkingInputFile Rename Sucessfull" << endl;
			return 1;
		} else if (RenameSucessfull != 0) {
			wstring value = L"Rename of ";
			value.append(WExtractDirectory(InputFileName));
			value.append(L" failed.");
			cursor_select++;
			Insert_Item_Into_Console(value);
			RRLOG << value << endl; 
			if (debugging == 1) Debug << L"ProcessFiles WorkingInputFile Rename Failure" << endl;
			return 0;
		}
		wstring value = L"rename error code : ";
		value.append(int2wstr(RenameSucessfull));
		cursor_select++;
		Insert_Item_Into_Console(value);
		RRLOG << value << endl;
	} else {
		wstring value = L"File Name Not Altered.";
		cursor_select++;
		Insert_Item_Into_Console(value);
		RRLOG << value << endl;
		return 0;
	}

	return 0;
}













































