#pragma once

#include "stdafx.h"

#include "ColumnFunctions.cpp"
#include "ListFunctions.cpp"
#include "BrowseForFile.cpp"
#include "SaveSessions.cpp"
#include "Scroll.cpp"
#include "Settings.cpp"
#include "RulesFileFunctions.cpp"
#include "Dialog.cpp"
#include "CSI_Functions_W.cpp"
#include "ReplaceFunctions.cpp"
#include "RenameFunctions.cpp"

using namespace std;

int APIENTRY _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, wchar_t* CmdLine, int nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);

	MSG msg;
	HACCEL hAccelTable;

	if (wcscmp(CmdLine,L"-Debug") == 0) {
		debugging = 1;
	} else {
		debugging = 0;
	}

	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_REPLACE, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_REPLACE));

	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}

ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_REPLACE));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_REPLACE);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}


BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   hInst = hInstance; 

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, SW_HIDE);
   UpdateWindow(hWnd);

   return TRUE;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	//HDC hDC, MemDCMainWindow;
	//PAINTSTRUCT Ps;
	//HBITMAP bmpMainWindow;

	switch (message)
	{
	case WM_LBUTTONDOWN:
		SaveWindowRect(L"Main", hWnd);
		break;
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		switch (wmId)
		{
		case IDM_ABOUT:
			ShowWindow(hAbout,SW_SHOW);
			LoadWindowRect(L"hAbout",hSettings);
			break;
		case ID_FILE_SETTINGS:
			if (loaded_settings == 0) 
			{
				loaded_settings = 1;
			    LoadSettings(hSettings);
			}
			ShowWindow(hSettings,SW_SHOW);
			LoadWindowRect(L"hSettings",hSettings);
			break;
		case IDOK:
		case IDCANCEL:
		case IDM_QUIT:
		case IDM_EXIT:
			if (debugging == 1) Debug.close();
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		//hDC = BeginPaint(hWnd, &Ps);
		//bmpMainWindow = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_MAIN_WINDOW));
		//MemDCMainWindow = CreateCompatibleDC(hDC);
		//SelectObject(MemDCMainWindow, bmpMainWindow);
		//StretchBlt(hDC, 0, 0, cxClient + 10, cyClient + 10, MemDCMainWindow, 0, 0, 800, 600, SRCCOPY);
		//DeleteDC(MemDCMainWindow);
		//DeleteObject(bmpMainWindow);
		//EndPaint(hWnd, &Ps);
		break;
	case WM_DESTROY:
		Debug.close();
		PostQuitMessage(0);
		break;
   case WM_CREATE:
	    if (debugging == 1) {
			Debug.open(Debug_File,ios::trunc);
			if(Debug.bad()) {
				MessageBoxW(NULL, L"Load of Text File Failed ->", (LPCWSTR)Debug_File.c_str(), NULL);
			}
		}
		hAbout = CreateDialog(GetModuleHandle(NULL),MAKEINTRESOURCE(IDD_ABOUTBOX),hWnd, hAboutDialog);
		ShowWindow(hAbout, SW_HIDE);
		hSettings = CreateDialog(GetModuleHandle(NULL),MAKEINTRESOURCE(IDD_SETTINGS),hWnd, hSettingsDialog);
		ShowWindow(hSettings, SW_SHOW);
		hExtensions = CreateDialog(GetModuleHandle(NULL),MAKEINTRESOURCE(IDD_EXTENSIONS),hWnd, hExtensionsDialog);
		ShowWindow(hExtensions, SW_HIDE);
		hReplaceList = CreateDialog(GetModuleHandle(NULL),MAKEINTRESOURCE(IDD_REPLACE_LIST),hWnd, hReplaceListDialog);
		ShowWindow(hReplaceList, SW_HIDE);
		hReplaceListEdit = CreateDialog(GetModuleHandle(NULL),MAKEINTRESOURCE(IDD_REPLACE_LIST_EDIT),hWnd, hReplaceListEditDialog);
		ShowWindow(hReplaceListEdit, SW_HIDE);
		hRenameListEdit = CreateDialog(GetModuleHandle(NULL),MAKEINTRESOURCE(IDD_RENAME_LIST_EDIT),hWnd, hRenameListEditDialog);
		ShowWindow(hRenameListEdit, SW_HIDE);
		if (loaded_settings == 0) 
		{
			loaded_settings = 1;
			LoadSettings(hSettings);
		}
		for (int k = 0;k < 300;k++) {
			for (int l = 0;l < 2;l++) {
				StringsArray[k][l] = L"Not Being Used";
			}
		}
		Insert_List_Items_From_Array();
		Insert_Item_Into_Console(L"Program Loaded");
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

