#pragma once

#include "stdafx.h"

using namespace std;

int GetReplaceFileName()
{
	if (debugging == 1) Debug << L"GetReplaceFileName Fired" << endl;
	GetDlgItemText(hSettings,IDC_RECURSE_FOLDER,ReplaceFileNamePath,250);
    NameFolder = wchar_t2wstr(ReplaceFileNamePath);
    DirectoryPath = WExtractDirectory(NameFolder);
	if (debugging == 1) Debug << L"GetReplaceFileName Completed" << endl;
	return 0;
}

bool ListFilesReplace(wstring path, wstring mask, vector<wstring>& files) { 
	HANDLE hFind = INVALID_HANDLE_VALUE; 
	WIN32_FIND_DATA ffd; 
	wstring spec; 
	stack<wstring> directories; 
	directories.push(path); 
	files.clear(); 
	if (recurse_subfolders == 1) {
		//cout << "recurse" << endl;
		while (!directories.empty()) { 
			path = directories.top(); 
			spec = path + L"\\" + mask; 
			directories.pop(); 
			hFind = FindFirstFile(spec.c_str(), &ffd); 
			if (hFind == INVALID_HANDLE_VALUE)  { 
				return false; 
			}  
			do { 
				if (wcscmp(ffd.cFileName, L".") != 0 &&  
				wcscmp(ffd.cFileName, L"..") != 0) { 
					if (ffd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) { 
						directories.push(path + L"\\" + ffd.cFileName);
					} 
					else { 
						files.push_back(path + L"\\" + ffd.cFileName); 
					} 
				} 
			} while (FindNextFile(hFind, &ffd) != 0); 
			if (GetLastError() != ERROR_NO_MORE_FILES) { 
				FindClose(hFind); 
				return false; 
			} 
			FindClose(hFind); 
			hFind = INVALID_HANDLE_VALUE; 
		} 
	    return true; 
	} else if (recurse_subfolders == 0) {
		if (!directories.empty()) { 
			path = directories.top(); 
			spec = path + L"\\" + mask; 
			directories.pop(); 
			hFind = FindFirstFile(spec.c_str(), &ffd); 
			if (hFind == INVALID_HANDLE_VALUE)  { 
				return false; 
			}  
			do { 
				if (wcscmp(ffd.cFileName, L".") != 0 &&  
				wcscmp(ffd.cFileName, L"..") != 0) { 
					if (ffd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) { 
						directories.push(path + L"\\" + ffd.cFileName);
					} 
					else { 
						files.push_back(path + L"\\" + ffd.cFileName); 
					} 
				} 
			} while (FindNextFile(hFind, &ffd) != 0); 
			if (GetLastError() != ERROR_NO_MORE_FILES) { 
				FindClose(hFind); 
				return false; 
			} 
			FindClose(hFind); 
			hFind = INVALID_HANDLE_VALUE; 
		}  
	}
	return true;
} 

void ProcessRecurseFiles()
{ 
	if (debugging == 1) Debug << L"ProcessRecurseFiles() Fired " << endl;
	GreyDialogSettings();
	GetReplaceFileName();
	number_of_files_searched = 0;
	number_of_files = 0;
	number_of_replaced_files = 0;
	TrackStringsReplaced = 0;
	RRLOG.open(L"ReplaceRename.log",ios::trunc);
	if(RRLOG.bad()) {
		MessageBoxW(NULL, L"Opening of log failed ->", L"Replace.log", NULL);
	}
	if (all_files_in_folder == 0 && recurse_subfolders == 0) {
		number_of_replaced_files+=ProcessFiles(NameFolder);
		number_of_files++;
		if (debugging == 1) Debug << L"ProcessRecurseFiles() Single File " << endl;
	} else {
		if (debugging == 1) Debug << L"ProcessRecurseFiles() Multiple Files " << endl;
		vector<wstring> files; 
		if (debugging == 1) Debug << L"ProcessRecurseFiles() path " << DirectoryPath << endl;
		wstring value = L"Starting in : ";
		value.append(DirectoryPath);
		DirectoryPath.erase(DirectoryPath.end()-1);
		cursor_select++;
		Insert_Item_Into_Console(value);
		RRLOG << value << endl;
		if (ListFilesReplace(DirectoryPath, L"*.*", files))  
		{ 
			if (debugging == 1) Debug << L" ListFiles starting in -> " << DirectoryPath << endl;
			for (vector<wstring>::iterator it = files.begin();it != files.end(); ++it) 
			{
				wchar_t* Name = cwchar_t2wchar_t(it->c_str());
				number_of_files_searched++;
				if (debugging == 1) Debug << L" wchar_t* Name = cwchar_t2wchar_t(it->c_str()); " << cwchar_t2wchar_t(it->c_str()) << endl;
				if (debugging == 1) Debug << L" ListFiles files.begin() " << endl;
				pos = 0;
				k = 0;
				wstring none = L"None";
				InputFile = wchar_t2wstr(Name);
				if (debugging == 1) Debug << L" file name ->>" << InputFile << endl;
				size_t loc = 0;
				if (Ext1.compare(none) != 0) 
				{
					loc = CI_CompareW(Ext1,InputFile);
					if (loc!=string::npos) 
					{
						wstring value = L"Found File : ";
						value.append(InputFile);
						cursor_select++;
						Insert_Item_Into_Console(value);
						RRLOG << value << endl;
						if (debugging == 1) Debug << L"ListFiles found usable file -> " << InputFile << endl;
						k += ProcessFiles(InputFile);
						number_of_files++;
					}
				}
				loc = 0;
				if (Ext2.compare(none) != 0) 
				{
					loc = CI_CompareW(Ext2,InputFile);
					if (loc!=string::npos) 
					{
						wstring value = L"Found File : ";
						value.append(InputFile);
						cursor_select++;
						Insert_Item_Into_Console(value);
						RRLOG << value << endl;
						if (debugging == 1) Debug << L"ListFiles found usable file -> " << InputFile << endl;
						k += ProcessFiles(InputFile);
						number_of_files++;
					}
				}
				loc = 0;
				if (Ext3.compare(none) != 0) 
				{
					loc = CI_CompareW(Ext3,InputFile);
					if (loc!=string::npos) 
					{
						wstring value = L"Found File : ";
						value.append(InputFile);
						cursor_select++;
						Insert_Item_Into_Console(value);
						RRLOG << value << endl;
						if (debugging == 1) Debug << L"ListFiles found usable file -> " << InputFile << endl;
						k += ProcessFiles(InputFile);
						number_of_files++;
					}
				}
				loc = 0;
				if (Ext4.compare(none) != 0) 
				{
					loc = CI_CompareW(Ext4,InputFile);
					if (loc!=string::npos) 
					{
						wstring value = L"Found File : ";
						value.append(InputFile);
						cursor_select++;
						Insert_Item_Into_Console(value);
						RRLOG << value << endl;
						if (debugging == 1) Debug << L"ListFiles found usable file -> " << InputFile << endl;
						k += ProcessFiles(InputFile);
						number_of_files++;
					}
				}
				loc = 0;
				if (Ext5.compare(none) != 0) 
				{
					loc = CI_CompareW(Ext5,InputFile);
					if (loc!=string::npos) 
					{
						wstring value = L"Found File : ";
						value.append(InputFile);
						cursor_select++;
						Insert_Item_Into_Console(value);
						RRLOG << value << endl;
						if (debugging == 1) Debug << L"ListFiles found usable file -> " << InputFile << endl;
						k += ProcessFiles(InputFile);
						number_of_files++;
					}
				}
				loc = 0;
				if (Ext6.compare(none) != 0) 
				{
					loc = CI_CompareW(Ext6,InputFile);
					if (loc!=string::npos) 
					{
						wstring value = L"Found File : ";
						value.append(InputFile);
						cursor_select++;
						Insert_Item_Into_Console(value);
						RRLOG << value << endl;
						if (debugging == 1) Debug << L"ListFiles found usable file -> " << InputFile << endl;
						k += ProcessFiles(InputFile);
						number_of_files++;
					}
				}
				loc = 0;
				if (Ext7.compare(none) != 0) 
				{
					loc = CI_CompareW(Ext7,InputFile);
					if (loc!=string::npos) 
					{
						wstring value = L"Found File : ";
						value.append(InputFile);
						cursor_select++;
						Insert_Item_Into_Console(value);
						RRLOG << value << endl;
						if (debugging == 1) Debug << L"ListFiles found usable file -> " << InputFile << endl;
						k += ProcessFiles(InputFile);
						number_of_files++;
					}
				}
				loc = 0;
				if (Ext8.compare(none) != 0) 
				{
					loc = CI_CompareW(Ext8,InputFile);
					if (loc!=string::npos) 
					{
						wstring value = L"Found File : ";
						value.append(InputFile);
						cursor_select++;
						Insert_Item_Into_Console(value);
						RRLOG << value << endl;
						if (debugging == 1) Debug << L"ListFiles found usable file -> " << InputFile << endl;
						k += ProcessFiles(InputFile);
						number_of_files++;
					}
				}
				loc = 0;
				if (Ext9.compare(none) != 0) 
				{
					loc = CI_CompareW(Ext9,InputFile);
					if (loc!=string::npos) 
					{
						wstring value = L"Found File : ";
						value.append(InputFile);
						cursor_select++;
						Insert_Item_Into_Console(value);
						RRLOG << value << endl;
						if (debugging == 1) Debug << L"ListFiles found usable file -> " << InputFile << endl;
						k += ProcessFiles(InputFile);
						number_of_files++;
					}
				}
				loc = 0;
				if (Ext10.compare(none) != 0) 
				{
					loc = CI_CompareW(Ext10,InputFile);
					if (loc!=string::npos) 
					{
						wstring value = L"Found File : ";
						value.append(InputFile);
						cursor_select++;
						Insert_Item_Into_Console(value);
						RRLOG << value << endl;
						if (debugging == 1) Debug << L"ListFiles found usable file -> " << InputFile << endl;
						k += ProcessFiles(InputFile);
						number_of_files++;
					}
				}
				number_of_replaced_files+=k;
			} 
		}
	}
	if (debugging == 1) Debug << L"ProcessRecurseFiles() Completed" << endl;
    SetDialogSettingsSpecific(0);
	wstring value = L"Searched ";
	value.append(int2wstr(number_of_files_searched));
	value.append(L" total files.Replaced ");
	value.append(int2wstr(TrackStringsReplaced));
	value.append(L" total strings in ");
	value.append(int2wstr(number_of_replaced_files));
	value.append(L" files.Total of ");
	value.append(int2wstr(number_of_files));
	value.append(L" files with matching extensions.");
	cursor_select++;
	Insert_Item_Into_Console(value);
	hConsole = GetDlgItem(hSettings,IDC_CONSOLE_LIST);
	SendMessage(hConsole,LVM_ENSUREVISIBLE ,(WPARAM)cursor_select,FALSE);
	RRLOG << value << endl; 
	RRLOG.close();
}

int ProcessFiles(wstring InputFileName) 
{
	if (debugging == 1) Debug << L"ProcessFiles fired" << endl;
    wstring WorkingLine = L"";
    StringsReplaced = 0;
	wstring PreservedInputFileName = cpywstr(InputFileName);
	if (debugging == 1) Debug << L"ProcessFiles PreservedInputFileName " << PreservedInputFileName << endl;
	wstring WorkingOutputFileName = cpywstr(InputFileName);
	wstring WorkingOutputDirectory = WExtractDirectory(InputFileName);
	if (debugging == 1) Debug << L"ProcessFiles WorkingOutputFileName " << WorkingOutputFileName << endl;
    wstring look_for = L"";
	wstring replace_with = L"";
	WorkingOutputFileName.append(L".Replaced");
	wstring PreservedOutputFileName = cpywstr(WorkingOutputFileName);
	int check = CopyFile(PreservedInputFileName.c_str(),PreservedOutputFileName.c_str(),false);
	wofstream WorkingOutputFileStream(WorkingOutputFileName,ios::in|ios::out|ios::binary|ios::trunc);
	if (!WorkingOutputFileStream.is_open()) 
	{
		if (debugging == 1) Debug << L"ProcessFiles WorkingOutputFile.bad()" << endl;
	} else {
	    if (debugging == 1) Debug << L"ProcessFiles WorkingOutputFile.good()" << endl;
	}
	wifstream WorkingInputFileStream(PreservedInputFileName,ios::in|ios::out|ios::binary);
	if (!WorkingInputFileStream.is_open()) 
	{
		if (debugging == 1) Debug << L"ProcessFiles WorkingInputFile.bad()" << endl;
	} else {
	    if (debugging == 1) Debug << L"ProcessFiles WorkingInputFile.good()" << endl;
	}
	while ( getline( WorkingInputFileStream , WorkingLine ) ) 
	{
		if (debugging == 1) Debug << L"WorkingLine getline Loop-> " << WorkingLine << endl;
		for (int j = 0;j < 150;j++) 
		{
			for (int Step = 0;Step < 2;Step++)
			{
				if (Step == 0)
				{
					look_for = cpywstr(StringsArray[j][Step]);
				} 
				else if (Step == 1) 
				{
					replace_with = cpywstr(StringsArray[j][Step]);
					if (debugging == 1) Debug << L"replace_with-> " << replace_with << L" look_for-> " << look_for << endl;
					if ((look_for.compare(L"Not Being Used") != 0 && replace_with.compare(L"Not Being Used") != 0) && (look_for.compare(L"") != 0 && replace_with.compare(L"") != 0) && (look_for.compare(replace_with) != 0) && (replace_with.compare(look_for) != 0))
					{
						if (debugging == 1) Debug << L"WorkingLine Before replace-> " << WorkingLine << endl;
						WorkingLine = CSI_Replacew(look_for,WorkingLine,replace_with);
						if (debugging == 1) Debug << L"WorkingLine After replace-> " << WorkingLine << endl;
					}
				}
			}
		}
		WorkingOutputFileStream << WorkingLine << endl;
		//WorkingLine.erase();
	}
	WorkingInputFileStream.close();
	WorkingOutputFileStream.close();
	if ( new_file != 1 ) {
		if (StringsReplaced > 0) {
			int check = CopyFile(PreservedOutputFileName.c_str(),PreservedInputFileName.c_str(),false);
			if (check != 0) {
				wstring value = L"CopyFile error code : ";
				value.append(int2wstr(check));
				value.append(L" CopyFile Sucessfull");
				//cursor_select++;
				//Insert_Item_Into_Console(value);
				RRLOG << value << endl;
				remove(wstr2str(PreservedOutputFileName).c_str());
				if (debugging == 1) Debug << L"ProcessFiles CopyFile Sucessfull" << endl;
			} else if (check == 0) {
				wstring value = L"CopyFile error code : ";
				value.append(int2wstr(check));
				value.append(L" CopyFile Failed");
				//cursor_select++;
				//Insert_Item_Into_Console(value);
				RRLOG << value << endl;
				remove(wstr2str(PreservedOutputFileName).c_str());
				if (debugging == 1) Debug << L"ProcessFiles CopyFile Failed" << endl;
			}
		} else {
			remove(wstr2str(PreservedOutputFileName).c_str());
		}
	}
	wstring value = L"Replaced ";
	value.append(int2wstr(StringsReplaced));
	value.append(L" strings in ");
	value.append(WExtractFileName(PreservedInputFileName));
	value.append(L".");
	cursor_select++;
	Insert_Item_Into_Console(value);
	RRLOG << value << endl; 
	if (StringsReplaced > 0) {
		TrackStringsReplaced+=StringsReplaced;
		return 1;
	} else {
		return 0;
	}
}














































